<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    
</head>
<body>
    <div id="app">
        <counter></counter>
    </div>

    <script src="https://unpkg.com/vue@2.6.10/dist/vue.js"></script>
    <script src="https://unpkg.com/vuex@3.1.0/dist/vuex.js"></script>
    <script>

    const Counter = Vue.extend({
        name: 'counter',
        methods: {
            // inc() {
            //     this.$store.state.count++; // NOOOOOOO, mutations !!!
            // }
            fetchProducts() {
                // fetch('https://api.myjson.com/bins/74l63')
                //     .then(response => response.json())
                //     .then(json => this.products  = json.products)
                //     .then(products => $store.commit('updateproducts', products))

                this.$store.dispatch('updateProducts');
            }

        },
        template: `<div>
                {{ $store.state.count }}
                <button @click="$store.commit('incr')">incr</button>
                <button @click="fetchProducts">fetch products</button>
                <ul>
                    <li v-for="p in $store.state.products">{{p}}</li>
                </ul>
            </div>`
    })

    const store = new Vuex.Store({
        state: {
            count: 0,
            currentSelectedItem: null,
            products: [] 
        },
        mutations: {
            incr(state) {
                state.count += 1
            },
            decr(state) {
                state.count -= 1
            },
            updatecount(state, n) {
                state.count += n
            },
            updateProducts(state, products) {
                state.products = products;
            }
            // updateProducts(state) { // NOOOO, les mutations sont synchrones
            //     fetch('https://api.myjson.com/bins/74l63')
            //         .then(response => response.json())
            //         .then(json => this.products  = json.products)
            //         .then(products => state.products = products);
            // } 
        },
        actions: {
            updateProducts(context) {
                fetch('https://api.myjson.com/bins/74l63')
                    .then(response => response.json())
                    .then(json => this.products  = json.products)
                    .then(products => context.commit('updateProducts', products));
            }
        }
    });

    const app = new Vue({
        el: "#app",
        store,
        components: { Counter }
    })
    </script>
</body>
</html>